"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Icons = exports.getIconUri = void 0;
const path = require("path");
const vscode_1 = require("vscode");
const iconsRootPath = path.join(path.dirname(__dirname), '..', 'resources', 'icons');
function getIconUri(iconName, theme) {
    return vscode_1.Uri.file(path.join(iconsRootPath, theme, `${iconName}.svg`));
}
exports.getIconUri = getIconUri;
exports.Icons = {
    light: {
        Modified: getIconUri('status-modified', 'light'),
        Added: getIconUri('status-added', 'light'),
        Deleted: getIconUri('status-deleted', 'light'),
        Renamed: getIconUri('status-renamed', 'light'),
        Copied: getIconUri('status-copied', 'light')
    },
    dark: {
        Modified: getIconUri('status-modified', 'dark'),
        Added: getIconUri('status-added', 'dark'),
        Deleted: getIconUri('status-deleted', 'dark'),
        Renamed: getIconUri('status-renamed', 'dark'),
        Copied: getIconUri('status-copied', 'dark')
    }
};
//# sourceMappingURL=icons.js.map